/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : GR / service receipt posting
*/

CREATE PROCEDURE [dbo].[SP_DLV_POSTING_GR_20161007]
	@Username varchar(max),
	@pid bigint,
	@SourceString as varchar(max),
	@SAtype VARCHAR(30) = 'TRANS_CD_SA_POSTING',
	@Stats VARCHAR(10) = 'SUCCESS' OUTPUT
AS
BEGIN	
	DECLARE @CPC as varchar(max)
	--DECLARE @Username as varchar(max) = 'MML.goldy'
	--DECLARE @pid as bigint = 201404280001
	--DECLARE @SourceString as varchar(max) = 'R201402188851,R201402189231,R201402189232,R201402189376'
	DECLARE @log as varchar(max)
	DECLARE @T AS TABLE (PID BIGINT)
	DECLARE @x XML;
	SET @x = '<r>' + REPLACE((SELECT @SourceString FOR XML PATH('')), ',', '</r><r>') + '</r>';

	DECLARE @CURS_STAT as int

	SET @log = 'Posting GR by SP_DLV_POSTING_GR';
	INSERT @T
	EXEC dbo.sp_PutLog @log, @Username, 'SP_DLV_POSTING_GR', @pid OUTPUT, 'MPCS00002INF', 'INF', '3', '31301';

	BEGIN TRY
		SELECT 
		DOC_YEAR, 
		DOC_DT,
		POSTING_DT, 
		DOC_HEADER_TXT, 
		REFF_NO, 
		PAYMENT_TERM_CD, 
		LP_CD,
		CUSTOMER_CD, 
		PAYMENT_METHOD_CD, 
		PARTNER_BANK_KEY, 
		ACCT_DOC_NO, 
		ACCT_DOC_YEAR, 
		HEADER_TYPE
		into #loop
		FROM
		(
			SELECT 
			YEAR(grir.DOC_DT) as DOC_YEAR, 
			grir.DOC_DT,
			GETDATE() as POSTING_DT,
			grir.REFF_NO as DOC_HEADER_TXT,
			grir.SERVICE_DOC_NO+'-'+CAST(YEAR(grir.DOC_DT) as varchar(max)) as REFF_NO,
			--poh.PAYMENT_TERM_CD,
			NULL as PAYMENT_TERM_CD,
			grir.LP_CD,
			NULL as CUSTOMER_CD,
			--poh.PAYMENT_METHOD_CD,
			NULL as PAYMENT_METHOD_CD,
			--1 as PARTNER_BANK_KEY,
			NULL as PARTNER_BANK_KEY,
			NULL as ACCT_DOC_NO,
			NULL as ACCT_DOC_YEAR,
			NULL as HEADER_TYPE
			FROM TB_R_DLV_GR_IR grir
			LEFT JOIN TB_R_DLV_PO_H poh ON poh.PO_NO = grir.PO_NO
			WHERE grir.CONDITION_CATEGORY = 'H' AND 
					(
						((grir.CANCEL_STS IS NULL) AND (grir.SA_CANCEL_REFF_NO IS NULL) AND (@SAtype = 'TRANS_CD_SA_POSTING'))
						OR
						((grir.CANCEL_STS  = '1') AND (grir.SA_CANCEL_REFF_NO IS NULL) AND (@SAtype = 'TRANS_CD_SA_CANCEL_POSTING'))
					)
				AND grir.REFF_NO = @SourceString
			--WHERE grir.CONDITION_CATEGORY = 'H' AND grir.CANCEL_STS IS NULL AND grir.SA_CANCEL_REFF_NO IS NULL AND grir.REFF_NO IN (SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(1000)') AS Value FROM    @x.nodes('/r') y(XmlCol))
		)tbl;


		DECLARE 
		@DOC_YEAR as varchar(4),
		@DOC_DT as date, 
		@POSTING_DT as datetime, 
		@DOC_HEADER_TXT as varchar(25), 
		@REFF_NO as varchar(16), 
		@PAYMENT_TERM_CD as varchar(4), 
		@LP_CD as varchar(4), 
		@CUSTOMER_CD as varchar(10), 
		@PAYMENT_METHOD_CD as varchar(4), 
		@PARTNER_BANK_KEY as varchar(10), 
		@ACCT_DOC_NO as varchar(10), 
		@ACCT_DOC_YEAR as varchar(4), 
		@HEADER_TYPE as varchar(2), 
		@CREATED_BY as varchar(20), 
		@CREATED_DT as datetime

		DECLARE BTMP_CURS2 CURSOR 
		FOR 
		SELECT 
		DOC_YEAR, 
		DOC_DT,
		POSTING_DT, 
		DOC_HEADER_TXT, 
		REFF_NO, 
		PAYMENT_TERM_CD, 
		LP_CD, 
		CUSTOMER_CD, 
		PAYMENT_METHOD_CD, 
		PARTNER_BANK_KEY, 
		ACCT_DOC_NO, 
		ACCT_DOC_YEAR, 
		HEADER_TYPE
		FROM #loop;

		OPEN BTMP_CURS2;
		FETCH NEXT FROM BTMP_CURS2 INTO @DOC_YEAR,@DOC_DT,@POSTING_DT,@DOC_HEADER_TXT, @REFF_NO, @PAYMENT_TERM_CD,@LP_CD,@CUSTOMER_CD,@PAYMENT_METHOD_CD,@PARTNER_BANK_KEY,@ACCT_DOC_NO,@ACCT_DOC_YEAR,@HEADER_TYPE
		WHILE @@FETCH_STATUS = 0  
		BEGIN  
			DECLARE @LAST_DOC_NO as VARCHAR(20) = (SELECT TOP 1 DOC_NO FROM TB_R_DLV_FI_TRANS_H WHERE DOC_NO LIKE 'CS%' ORDER BY DOC_NO DESC)
			DECLARE @DOC_NO as varchar(max) = ''
			DECLARE @DIGITS as varchar(10) = '0000000000' --nanti masukin ke system master
			DECLARE @ADDS as varchar(max)
			IF(@LAST_DOC_NO IS NULL)
			BEGIN
				SET @DOC_NO = 'CS0000000001'
			END
			ELSE
			BEGIN
				SET @ADDS = (SELECT CAST(SUBSTRING(@LAST_DOC_NO ,3,10) as numeric)+1)
				SET @DOC_NO = (SELECT 'CS'+SUBSTRING(@DIGITS,1,LEN(@DIGITS)-LEN(@ADDS))+@ADDS)
			END
			
			
			SET @log = 'Insert DOC_NO: '+@DOC_NO+', DOC_HEADER_TXT : '+@DOC_HEADER_TXT+' into TRANS_H by SP_DLV_POSTING_GR';
			INSERT @T
			EXEC dbo.sp_PutLog @log, @Username, 'SP_DLV_POSTING_GR', @pid OUTPUT, 'MPCS00002INF', 'INF', '3', '31301';
			
			INSERT INTO TB_R_DLV_FI_TRANS_H(DOC_NO,DOC_YEAR,DOC_DT,POSTING_DT,DOC_HEADER_TXT,REFF_NO,PAYMENT_TERM_CD,LP_CD,CUSTOMER_CD,PAYMENT_METHOD_CD,PARTNER_BANK_KEY,ACCT_DOC_NO,ACCT_DOC_YEAR,HEADER_TYPE, CREATED_BY, CREATED_DT, PROCESS_ID)
			SELECT @DOC_NO, @DOC_YEAR, @DOC_DT, @POSTING_DT, @DOC_HEADER_TXT, @REFF_NO, @PAYMENT_TERM_CD, @LP_CD, @CUSTOMER_CD, @PAYMENT_METHOD_CD, @PARTNER_BANK_KEY, @ACCT_DOC_NO, @ACCT_DOC_YEAR, @HEADER_TYPE, @Username, GETDATE(), @pid
			
			
			
			--TAKING RULE_D
			
			
			
			SELECT TRANS_TYPE_CD, DEBIT_CREDIT_IND,CONDITION_TYPE, POSTING_CD INTO #tb_rule_d FROM(
				SELECT TRANS_TYPE_CD, DEBIT_CREDIT_IND, CONDITION_TYPE, POSTING_CD FROM TB_M_FI_POSTING_RULE_D
			WHERE TRANS_TYPE_CD = (SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = @SAtype)

			)tbl;
			DECLARE 
			@TRANS_TYPE_CD as varchar(3),
			@DEBIT_CREDIT_IND as varchar(1),
			@CONDITION_TYPE as varchar(4),
			@POSTING_CD as varchar(2)

			DECLARE RULE_D_CURS CURSOR 
			FOR SELECT TRANS_TYPE_CD, DEBIT_CREDIT_IND, CONDITION_TYPE, POSTING_CD from #tb_rule_d ORDER BY DEBIT_CREDIT_IND DESC;
			OPEN RULE_D_CURS;
			FETCH NEXT FROM RULE_D_CURS INTO @TRANS_TYPE_CD, @DEBIT_CREDIT_IND, @CONDITION_TYPE, @POSTING_CD
			WHILE @@FETCH_STATUS = 0  
			BEGIN 
				--DECLARE @CPC as varchar(max) = (SELECT COMP_PRICE_CD FROM TB_R_DLV_GR_IR WHERE CONDITION_CATEGORY = 'H' AND CANCEL_STS IS NULL AND REFF_NO = @DOC_HEADER_TXT)
				IF (@SAtype = 'TRANS_CD_SA_CANCEL_POSTING')
					SET @CPC = (SELECT COMP_PRICE_CD FROM TB_R_DLV_GR_IR WHERE CONDITION_CATEGORY = 'H' AND SA_CANCEL_REFF_NO IS NULL AND REFF_NO = @DOC_HEADER_TXT)
				ELSE
					SET @CPC = (SELECT COMP_PRICE_CD FROM TB_R_DLV_GR_IR WHERE CONDITION_CATEGORY = 'H' AND CANCEL_STS IS NULL AND REFF_NO = @DOC_HEADER_TXT)
			--SELECT @DOC_HEADER_TXT
			
			--SELECT @TRANS_TYPE_CD, @DEBIT_CREDIT_IND, @CONDITION_TYPE, @POSTING_CD
				DECLARE @LASTNUM as int = (SELECT MAX(DOC_ITEM_NO) FROM TB_R_DLV_FI_TRANS_D WHERE DOC_NO = @DOC_NO AND DOC_YEAR = @DOC_YEAR)			
				
			
				
				
				--IF(@DEBIT_CREDIT_IND = 'D')
				IF(@CONDITION_TYPE = @CPC)
				BEGIN
					
					SET @log = 'Insert DEBIT_CREDIT_IND: '+@DEBIT_CREDIT_IND+', TRANS_TYPE : '+@TRANS_TYPE_CD+', CONDITION_TYPE :'+@CONDITION_TYPE+' TRANS_D by SP_DLV_POSTING_GR';
					INSERT @T
					EXEC dbo.sp_PutLog @log, @Username, 'SP_DLV_POSTING_GR', @pid OUTPUT, 'MPCS00002INF', 'INF', '3', '31301';
					
					INSERT INTO TB_R_DLV_FI_TRANS_D (DOC_NO, DOC_YEAR, DOC_ITEM_NO, CONDITION_TYPE, GL_ACCOUNT,ROUTE_CD, DOC_QTY, DOC_AMT, DOC_CURR_CD, LOCAL_AMT, LOCAL_CURR_CD, PO_NO, TAX_CD, EXCHANGE_RATE, COST_CENTER_CD, ITEM_TEXT, TRANSACTION_NO, WBS_NO, UOM, CREATED_BY, CREATED_DT)
					SELECT
					@DOC_NO as DOC_NO,
					@DOC_YEAR as DOC_YEAR,
					--a.ITEM_NO as DOC_ITEM_NO, 
					CASE WHEN @LASTNUM IS NULL THEN 1 ELSE @LASTNUM+1 END as DOC_ITEM_NO,
					@CONDITION_TYPE as CONDITION_TYPE,
					gl.GL_ACCOUNT,
					b.ROUTE_CD,
					b.TRANSACTION_QTY as DOC_QTY,
					CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN CASE WHEN a.GR_IR_AMT < 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END ELSE CASE WHEN a.GR_IR_AMT > 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END  END as DOC_AMT,
					a.ITEM_CURR as DOC_CURR_CD,
					CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN CASE WHEN a.GR_IR_AMT < 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END ELSE CASE WHEN a.GR_IR_AMT > 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END  END as LOCAL_AMT,
					a.ITEM_CURR as LOCAL_CURR_CD,
					CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN a.PO_NO ELSE NULL END as PO_NO,
					NULL as TAX_CD,
					po.PO_EXCHANGE_RATE,
					CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN (SELECT y.SYSTEM_VALUE FROM TB_M_SYSTEM y WHERE y.SYSTEM_CD = 'COST_CENTER') ELSE NULL END as COST_CENTER_CD,
					NULL as ITEM_TEXT,
					b.TRANSACTION_CD as TRANSACTION_NO,
					NULL as WBS_NO,
					'RET' as UOM,
					--@TRANS_TYPE_CD as TRANS_TYPE_CD,
					--@DEBIT_CREDIT_IND as DEBIT_CREDIT_IND,
					--@POSTING_CD as POSTING_CD,
					@Username,
					GETDATE()
					FROM TB_R_DLV_GR_IR a
					LEFT JOIN TB_M_SYSTEM syst ON syst.SYSTEM_CD = @SAtype
					LEFT JOIN TB_M_FI_POSTING_RULE_H rule_h ON rule_h.TRANS_TYPE_CD = syst.SYSTEM_VALUE
					LEFT JOIN TB_M_GL_ACCOUNT_MAPPING gl ON gl.POSTING_CD = @POSTING_CD AND gl.CONDITION_TYPE = @CONDITION_TYPE
					LEFT JOIN TB_R_DLV_SERVICE_DOC b ON b.SERVICE_DOC_NO = a.SERVICE_DOC_NO
					LEFT JOIN TB_R_DLV_PO_H po ON po.PO_NO = a.PO_NO
					WHERE a.CONDITION_CATEGORY = 'H' AND 
							(((a.CANCEL_STS IS NULL) AND (@SAtype = 'TRANS_CD_SA_POSTING'))
							OR
							((a.SA_CANCEL_REFF_NO IS NULL) AND (@SAtype = 'TRANS_CD_SA_CANCEL_POSTING')))
							AND a.REFF_NO = @DOC_HEADER_TXT AND a.SERVICE_DOC_NO IN (SELECT x.SERVICE_DOC_NO FROM TB_R_DLV_SERVICE_DOC x WHERE PROCESS_ID = @pid)
				END
				
				
				SET @log = 'Insert DEBIT_CREDIT_IND : '+@DEBIT_CREDIT_IND+' FI_JOURNAL by SP_DLV_POSTING_GR';
				INSERT @T
				EXEC dbo.sp_PutLog @log, @Username, 'SP_DLV_POSTING_GR', @pid OUTPUT, 'MPCS00002INF', 'INF', '3', '31301';
				
				INSERT INTO TB_R_DLV_FI_JOURNAL (DOC_NO, DOC_YEAR, DOC_ITEM, DOC_DT, TRANSACTION_CD, CONDITION_TYPE, DEBIT_CREDIT_INDICATOR, GL_ACCOUNT, ROUTE_CD, QTY, AMT_DOC, DOC_CURR, AMT_LOCAL, LOCAL_CURR, PO_NO, TAX_CD, EXCHANGE_RATE, COST_CENTER_CD, DOC_TYPE, GL_BALANCE_FLAG, WBS_NO, UOM, ITEM_TEXT, CREATED_BY, CREATED_DT, PROCESS_ID)
				SELECT
				@DOC_NO as DOC_NO,
				@DOC_YEAR as DOC_YEAR,
				CASE WHEN @LASTNUM IS NULL THEN 1 ELSE @LASTNUM+1 END as DOC_ITEM,
				@DOC_DT as DOC_DT,
				b.TRANSACTION_CD,
				@CONDITION_TYPE as CONDITION_TYPE,
				@DEBIT_CREDIT_IND as DEBIT_CREDIT_IND,
				gl.GL_ACCOUNT,
				b.ROUTE_CD,
				b.TRANSACTION_QTY as QTY,
				CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN CASE WHEN a.GR_IR_AMT < 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END ELSE CASE WHEN a.GR_IR_AMT > 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END  END as AMT_DOC,
				a.ITEM_CURR as DOC_CURR,
				CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN CASE WHEN a.GR_IR_AMT < 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END ELSE CASE WHEN a.GR_IR_AMT > 0 THEN a.GR_IR_AMT*(-1) ELSE a.GR_IR_AMT END  END as AMT_LOCAL,
				a.ITEM_CURR as LOCAL_CURR,
				CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN a.PO_NO ELSE NULL END as PO_NO,
				NULL as TAX_CD,
				po.PO_EXCHANGE_RATE,
				CASE WHEN @DEBIT_CREDIT_IND = 'D' THEN (SELECT y.SYSTEM_VALUE FROM TB_M_SYSTEM y WHERE y.SYSTEM_CD = 'COST_CENTER') ELSE NULL END as COST_CENTER_CD,
				rule_h.DOC_TYPE as DOC_TYPE,
				NULL as GL_BALANCE_FLAG,
				NULL as WBS_NO,
				'RET' as UOM,
				NULL as ITEM_TEXT,
				@Username,
				GETDATE(),
				@pid
				FROM TB_R_DLV_GR_IR a
				LEFT JOIN TB_M_SYSTEM syst ON syst.SYSTEM_CD = @SAtype
				LEFT JOIN TB_M_FI_POSTING_RULE_H rule_h ON rule_h.TRANS_TYPE_CD = syst.SYSTEM_VALUE
				LEFT JOIN TB_M_GL_ACCOUNT_MAPPING gl ON gl.POSTING_CD = @POSTING_CD AND gl.CONDITION_TYPE = @CONDITION_TYPE
				LEFT JOIN TB_R_DLV_SERVICE_DOC b ON b.SERVICE_DOC_NO = a.SERVICE_DOC_NO
				LEFT JOIN TB_R_DLV_PO_H po ON po.PO_NO = a.PO_NO
				WHERE a.CONDITION_CATEGORY = 'H' AND 
						(((a.CANCEL_STS IS NULL) AND (@SAtype = 'TRANS_CD_SA_POSTING'))
						OR
						((a.SA_CANCEL_REFF_NO IS NULL) AND (@SAtype = 'TRANS_CD_SA_CANCEL_POSTING')))
						AND a.REFF_NO = @DOC_HEADER_TXT AND a.SERVICE_DOC_NO IN (SELECT x.SERVICE_DOC_NO FROM TB_R_DLV_SERVICE_DOC x WHERE PROCESS_ID = @pid)
				
			FETCH NEXT FROM RULE_D_CURS INTO @TRANS_TYPE_CD, @DEBIT_CREDIT_IND, @CONDITION_TYPE, @POSTING_CD
			END;
			CLOSE RULE_D_CURS;
			DEALLOCATE RULE_D_CURS;
			drop table #tb_rule_d;
			
			--END TAKING RULE_D
			
			
			
		FETCH NEXT FROM BTMP_CURS2 INTO @DOC_YEAR,@DOC_DT,@POSTING_DT,@DOC_HEADER_TXT, @REFF_NO, @PAYMENT_TERM_CD,@LP_CD,@CUSTOMER_CD,@PAYMENT_METHOD_CD,@PARTNER_BANK_KEY,@ACCT_DOC_NO,@ACCT_DOC_YEAR,@HEADER_TYPE
		END;
		CLOSE BTMP_CURS2;
		DEALLOCATE BTMP_CURS2;
		drop table #loop;
		
		SET @log = 'Posting GR Success by SP_DLV_POSTING_GR';
		INSERT @T
		EXEC dbo.sp_PutLog @log, @Username, 'SP_DLV_POSTING_GR', @pid OUTPUT, 'MPCS00002INF', 'INF', '3', '31301';	
		
		UPDATE TB_R_DLV_FI_TRANS_H SET PROCESS_ID = NULL WHERE PROCESS_ID = @pid
		UPDATE TB_R_DLV_FI_JOURNAL SET PROCESS_ID = NULL WHERE PROCESS_ID = @pid
		UPDATE TB_R_DLV_SERVICE_DOC SET PROCESS_ID = NULL WHERE PROCESS_ID = @pid
		--UPDATE TB_R_DLV_QUEUE SET PROCESS_STATUS = 'QU3', PROCESS_END_DT = GETDATE() WHERE PROCESS_ID = @pid
		
	END TRY
	BEGIN CATCH
		SET @log = 'Failed posting GR by SP_DLV_POSTING_GR : ' + ERROR_MESSAGE();
		INSERT @T
		EXEC dbo.sp_PutLog @log, @Username, 'SP_DLV_POSTING_GR', @pid OUTPUT, 'MPCS00002INF', 'INF', '3', '31301';	

		SET @Stats = 'ERROR'

		--UPDATE TB_R_DLV_QUEUE SET PROCESS_STATUS = 'QU4', PROCESS_END_DT = GETDATE() WHERE PROCESS_ID = @pid
	END CATCH
	
	SET @CURS_STAT = (SELECT CURSOR_STATUS('global','RULE_D_CURS'));
	IF(@CURS_STAT = 1)
	BEGIN
		CLOSE RULE_D_CURS;
		DEALLOCATE RULE_D_CURS;
	END

	SET @CURS_STAT = 0
	SET @CURS_STAT = (SELECT CURSOR_STATUS('global','BTMP_CURS2'));
	IF(@CURS_STAT = 1)
	BEGIN
		CLOSE BTMP_CURS2;
		DEALLOCATE BTMP_CURS2;
	END

END

